GroupCalendarClock_Data = nil

GroupCalendar.cHelpClock = "Sets the minimap clock to display local time or server time"

function GroupCalendar.Clock:Initialize()
	if not GroupCalendarClock_Data then
		GroupCalendarClock_Data =
		{
			ShowLocalTime = false,
		}
	end
	
	self.Data = GroupCalendarClock_Data
	
	self.Frame = GroupCalendar:New(GroupCalendar._Clock, 32, GameTimeFrame, -1, 1, true)
	self.Frame:SetShowLocalTime(self.Data.ShowLocalTime)
	
	self.DateFontString = self.Frame:CreateFontString(nil, "ARTWORK", "SystemFont_Small")
	self.DateFontString:SetTextColor(77 / 255, 56 / 255, 0 / 255, 0.75)
	self.DateFontString:SetPoint("TOP", self.Frame, "CENTER", -2, 0)
	
	self.DateFontString:SetText(GameTimeFrame:GetText())
	GameTimeFrame:SetText("")
	GameTimeFrame.SetText = function (pFrame, pText) self.DateFontString:SetText(pText) end
end

function GroupCalendar:HookScript(pFrame, pScriptID, pFunction)
	if not pFrame:GetScript(pScriptID) then
		pFrame:SetScript(pScriptID, pFunction)
	else
		pFrame:HookScript(pScriptID, pFunction)
	end
end

----------------------------------------
-- /cal
----------------------------------------

if not GroupCalendar.InstallSlashCommand then
	function GroupCalendar:InstallSlashCommand()
		SlashCmdList.CAL = function (...) GroupCalendar:ExecuteCommand(...) end
		SLASH_CAL1 = "/cal"
	end

	function GroupCalendar:ExecuteCommand(pCommandString, ...)
		local _, _, vCommand, vParameter = string.find(pCommandString, "([^%s]+) ?(.*)")
		local vCommandFunc = self.Commands[strlower(vCommand or "help")] or self.Commands.help
		
		vCommandFunc(self, vParameter)
	end
	
	GroupCalendar.CommandHelp = {}
	GroupCalendar.Commands = {}
end

if GroupCalendar.EventLib then
	GroupCalendar.EventLib:RegisterEvent("GROUPCALENDAR_INIT", function () GroupCalendar.Clock:Initialize() end)
else
	GroupCalendar:HookScript(GameTimeFrame, "OnEvent", function (pFrame, pEventID) if pEventID == "VARIABLES_LOADED" then GroupCalendar.Clock:Initialize() end end)
	GameTimeFrame:RegisterEvent("VARIABLES_LOADED")
end

----------------------------------------
-- Commands
----------------------------------------

table.insert(GroupCalendar.CommandHelp, HIGHLIGHT_FONT_COLOR_CODE.."/cal clock [local|server]"..NORMAL_FONT_COLOR_CODE.." "..GroupCalendar.cHelpClock)

function GroupCalendar.Commands:clock(pParam)
	local vParam = pParam:lower()
	
	if vParam == "local" then
		self.Clock.Data.ShowLocalTime = true
	elseif vParam == "server" then
		self.Clock.Data.ShowLocalTime = false
	end
	
	if GroupCalendar.EventLib then
		GroupCalendar.EventLib:DispatchEvent("GC5_PREFS_CHANGED")
	end
end
