if not GroupCalendar then
	GroupCalendar =
	{
		AddonName = "GroupCalendar",
		AddonColorCode = "|cffcc88ff",
		AddonPath = "Interface\\Addons\\GroupCalendar5_Clock\\",
	}
	
	GroupCalendar.UI = {AddonPath = GroupCalendar.AddonPath}
	
	MCAddon = GroupCalendar
	
	function MCAddon:New(pMethodTable, ...)
		local vObject
		
		if type(pMethodTable) ~= "table" then
			error("table expected")
		end
		
		if pMethodTable._New then
			vObject = pMethodTable:_New(...)
		else
			vObject = {}
		end
		
		vObject.Inherit = self.Inherit
		
		vObject:Inherit(pMethodTable, ...)
		
		return vObject
	end

	function MCAddon:Inherit(pMethodTable, ...)
		for vKey, vValue in pairs(pMethodTable) do
			if self[vKey] then
				if not self.Inherited then
					self.Inherited = {}
				end
				
				self.Inherited[vKey] = self[vKey]
			end
			
			self[vKey] = vValue
		end
		
		if pMethodTable._Construct then
			pMethodTable._Construct(self, ...)
		end
	end

	function MCAddon:DuplicateTable(pTable, pRecurse, pDestTable)
		if not pTable then
			return nil
		end
		
		local vTable
		
		if pDestTable then
			if type(pDestTable) ~= "table" then
				error("table expected for pDestTable")
			end
			
			vTable = pDestTable
		else
			vTable = {}
		end
		
		if pRecurse then
			for vKey, vValue in pairs(pTable) do
				if type(vValue) == "table" then
					vTable[vKey] = self:DuplicateTable(vValue, true)
				else
					vTable[vKey] = vValue
				end
			end
		else
			self:CopyTable(vTable, pTable)
		end
		
		return vTable
	end

	function MCAddon:CopyTable(pDestTable, pTable)
		for vKey, vValue in pairs(pTable) do
			pDestTable[vKey] = vValue
		end
	end
else
	MCAddon = GroupCalendar
end

GroupCalendar.Clock = {}
